(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var experiment_1 = __importDefault(require("./experiment"));
var featureFlag_1 = __importDefault(require("./featureFlag"));
var Configuration = /** @class */ (function () {
    function Configuration(siteCode, actions) {
        this.updateTime = actions.updateTime ? actions.updateTime : new Date().getTime();
        this.configuration = actions;
        this.experiments = actions.experiments.filter(function (experiment) { return experiment.siteCode == siteCode; })
            .reduce(function (obj, experiment) {
            obj[experiment.id] = new experiment_1.default(experiment);
            return obj;
        }, {});
        this.featureFlags = actions.featureFlags.filter(function (ff) { return ff.siteCode == siteCode; })
            .reduce(function (obj, ff) {
            obj[ff.id] = new featureFlag_1.default(ff);
            return obj;
        }, {});
    }
    return Configuration;
}());
exports.default = Configuration;

},{"./experiment":2,"./featureFlag":3}],2:[function(require,module,exports){
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var targetingSegment_1 = __importDefault(require("../targeting/targetingSegment"));
var targetingTreeBuilder_1 = __importDefault(require("../targeting/targetingTreeBuilder"));
var variation_1 = __importDefault(require("./variation"));
var Experiment = /** @class */ (function () {
    function Experiment(experiment) {
        var _this = this;
        this.variationConfigurations = {};
        var deviations = experiment.deviations || null;
        if (deviations) {
            deviations.forEach(function (deviation) {
                var variationId = deviation.variationId;
                if (variationId == "origin") {
                    variationId = "0";
                }
                var deviationValue = deviation.value;
                var respTime = (experiment.respoolTime || []).find(function (resp) { return resp.variationId == variationId; });
                var respoolTimeValue = respTime ? respTime.value : null;
                var variation = (experiment.variations || []).find(function (variation) { return variation.id == variationId; });
                var customJsonString = variation ? variation.customJson : null;
                var customJson;
                try {
                    customJson = JSON.parse(customJsonString || "{}");
                }
                catch (e) {
                    customJson = {};
                }
                _this.variationConfigurations[variationId] = new variation_1.default(deviationValue, respoolTimeValue, customJson);
            });
            var targetingSegment = void 0;
            var segment = experiment.segment;
            if (null != segment) {
                targetingSegment = new targetingSegment_1.default();
                var conditionsData = segment.conditionsData;
                var targetingTree = targetingTreeBuilder_1.default.createTargetingTree(conditionsData);
                targetingSegment.targetingTree = targetingTree;
            }
            this.targetingSegment = targetingSegment;
        }
        this.siteEnabled = experiment.siteEnabled;
    }
    return Experiment;
}());
exports.default = Experiment;

},{"../targeting/targetingSegment":21,"../targeting/targetingTreeBuilder":23,"./variation":4}],3:[function(require,module,exports){
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var targetingSegment_1 = __importDefault(require("../targeting/targetingSegment"));
var targetingTreeBuilder_1 = __importDefault(require("../targeting/targetingTreeBuilder"));
var variation_1 = __importDefault(require("./variation"));
var FeatureFlag = /** @class */ (function () {
    function FeatureFlag(featureFlag) {
        var _this = this;
        this.isScheduleActive = function () {
            // if no schedules then need to fetch current status
            var currentStatus = _this.status == FeatureFlag.STATUS_ACTIVE;
            if (_this.featureStatus == FeatureFlag.FEATURE_STATUS_DEACTIVATED || _this.schedules.length == 0) {
                return currentStatus;
            }
            var currentTime = new Date().getTime();
            // need to find if currentTime is in any period -> active or not -> not activate
            return _this.schedules.filter(function (schedule) { return schedule.dateStart < currentTime && currentTime < schedule.dateEnd; }).length > 0;
        };
        this.variationConfigurations = {};
        this.identificationKey = featureFlag.identificationKey;
        this.status = featureFlag.status;
        this.featureStatus = featureFlag.featureStatus;
        this.schedules = [];
        var deviations = featureFlag.deviations || null;
        if (deviations) {
            deviations.forEach(function (deviation) {
                var variationId = deviation.variationId;
                if (variationId == "origin") {
                    variationId = "0";
                }
                var deviationValue = deviation.value;
                var respTime = (featureFlag.respoolTime || []).find(function (resp) { return resp.variationId == variationId; });
                var respoolTimeValue = respTime ? respTime.value : null;
                var variation = (featureFlag.variations || []).find(function (variation) { return variation.id == variationId; });
                var customJsonString = variation ? variation.customJson : null;
                var customJson;
                try {
                    customJson = JSON.parse(customJsonString || "{}");
                }
                catch (e) {
                    customJson = {};
                }
                _this.variationConfigurations[variationId] = new variation_1.default(deviationValue, respoolTimeValue, customJson);
            });
        }
        if (featureFlag.schedules) {
            featureFlag.schedules.forEach(function (schedule) {
                _this.schedules.push({
                    dateStart: schedule.dateStart ? Date.parse(schedule.dateStart) : -Infinity,
                    dateEnd: schedule.dateEnd ? Date.parse(schedule.dateEnd) : Infinity,
                });
            });
        }
        // Temporary fix for ff
        featureFlag.variations.forEach(function (variation) {
            if (!_this.variationConfigurations[variation.id]) {
                var deviation = 1 - _this.variationConfigurations["0"].deviation;
                var respTime = (featureFlag.respoolTime || []).find(function (resp) { return resp.variationId == variation.id; });
                var respoolTimeValue = respTime ? respTime.value : null;
                var customJsonString = variation.customJson;
                var customJson = void 0;
                try {
                    customJson = JSON.parse(customJsonString || "{}");
                }
                catch (e) {
                    customJson = {};
                }
                _this.variationConfigurations[variation.id] = new variation_1.default(deviation, respoolTimeValue, customJson);
            }
        });
        var targetingSegment;
        var segment = featureFlag.segment;
        if (null != segment) {
            targetingSegment = new targetingSegment_1.default();
            var conditionsData = segment.conditionsData;
            var targetingTree = targetingTreeBuilder_1.default.createTargetingTree(conditionsData);
            targetingSegment.targetingTree = targetingTree;
        }
        this.targetingSegment = targetingSegment;
        this.siteEnabled = featureFlag.siteEnabled;
    }
    FeatureFlag.STATUS_ACTIVE = "ACTIVE";
    FeatureFlag.FEATURE_STATUS_DEACTIVATED = "DEACTIVATED";
    return FeatureFlag;
}());
exports.default = FeatureFlag;

},{"../targeting/targetingSegment":21,"../targeting/targetingTreeBuilder":23,"./variation":4}],4:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Variation = /** @class */ (function () {
    function Variation(deviation, respoolTime, customJson) {
        this.deviation = deviation;
        this.respoolTime = respoolTime;
        this.customJson = customJson;
    }
    return Variation;
}());
exports.default = Variation;

},{}],5:[function(require,module,exports){
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Conversion = exports.Interest = exports.PageView = exports.Browser = exports.CustomData = void 0;
var nonce_1 = __importDefault(require("./nonce"));
var CustomData = /** @class */ (function () {
    function CustomData(id, value) {
        var _this = this;
        this.type = "CustomData";
        this.obtainFullPostTextLine = function () {
            var encodedValue = encodeURIComponent(JSON.stringify([[_this.value, 1]]));
            return "eventType=customData&index=" + _this.id + "&valueToCount=" + encodedValue + "&overwrite=true&nonce=" + _this.nonce;
        };
        this.id = id;
        this.value = value;
        this.nonce = (0, nonce_1.default)();
    }
    if (typeof window !== 'undefined') { window.CustomData = CustomData; } else if (typeof global !== 'undefined') { global.CustomData = CustomData; } 
    return CustomData;
}());
exports.CustomData = CustomData;
var Browser = /** @class */ (function () {
    function Browser(browser) {
        var _this = this;
        this.type = "Browser";
        this.obtainFullPostTextLine = function () {
            if (_this.browser < 0) {
                throw "Browser not recognized";
            }
            return "eventType=staticData&browser=" + _this.browser + "&nonce=" + _this.nonce;
        };
        this.browser = browser;
        this.nonce = (0, nonce_1.default)();
    }
    if (typeof window !== 'undefined') { window.Browser = Browser; } else if (typeof global !== 'undefined') { global.Browser = Browser; } 
    return Browser;
}());
exports.Browser = Browser;
var PageView = /** @class */ (function () {
    function PageView(url, title, referrer) {
        var _this = this;
        this.type = "PageView";
        this.obtainFullPostTextLine = function () {
            return "eventType=page&href=" + encodeURIComponent(_this.url) + "&title=" + _this.title + "&keyPages=[]" + (_this.referrer == null ? "" : "&referrers=[" + _this.referrer + "]") + "&nonce=" + _this.nonce;
        };
        this.url = url;
        this.title = title;
        this.referrer = referrer;
        this.nonce = (0, nonce_1.default)();
    }
    if (typeof window !== 'undefined') { window.PageView = PageView; } else if (typeof global !== 'undefined') { global.PageView = PageView; } 
    return PageView;
}());
exports.PageView = PageView;
var Interest = /** @class */ (function () {
    function Interest(index) {
        var _this = this;
        this.fresh = true;
        this.type = "Interest";
        this.obtainFullPostTextLine = function () {
            return "eventType=interests&indexes=[" + _this.index + "]&fresh=" + _this.fresh.toString() + "&nonce=" + _this.nonce;
        };
        this.index = index;
        this.nonce = (0, nonce_1.default)();
    }
    if (typeof window !== 'undefined') { window.Interest = Interest; } else if (typeof global !== 'undefined') { global.Interest = Interest; } 
    return Interest;
}());
exports.Interest = Interest;
var Conversion = /** @class */ (function () {
    function Conversion(goalId, revenue, negative) {
        var _this = this;
        if (revenue === void 0) { revenue = 0; }
        if (negative === void 0) { negative = false; }
        this.type = "Conversion";
        this.obtainFullPostTextLine = function () {
            return "eventType=conversion&goalId=" + _this.goalId.toString() + "&revenue=" + _this.revenue.toString() + "&negative=" + _this.negative.toString() + "&nonce=" + _this.nonce;
        };
        this.goalId = goalId;
        this.revenue = revenue;
        this.negative = negative;
        this.nonce = (0, nonce_1.default)();
    }
    if (typeof window !== 'undefined') { window.Conversion = Conversion; } else if (typeof global !== 'undefined') { global.Conversion = Conversion; } 
    return Conversion;
}());
exports.Conversion = Conversion;
exports.default = {
    browsers: { "CHROME": 0, "INTERNET_EXPLORER": 1, "FIREFOX": 2, "SAFARI": 3, "OPERA": 4, "OTHER": 5 },
    Conversion: Conversion,
    CustomData: CustomData,
    Browser: Browser,
    PageView: PageView,
    Interest: Interest
};

},{"./nonce":16}],6:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var CredentialsNotFound = /** @class */ (function (_super) {
    __extends(CredentialsNotFound, _super);
    function CredentialsNotFound(message) {
        var _this = _super.call(this) || this;
        _this.type = "CredentialsNotFound";
        _this.message = message;
        return _this;
    }
    return CredentialsNotFound;
}(Error));
exports.default = CredentialsNotFound;

},{}],7:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ExperimentConfigurationNotFound = /** @class */ (function (_super) {
    __extends(ExperimentConfigurationNotFound, _super);
    function ExperimentConfigurationNotFound(message) {
        var _this = _super.call(this) || this;
        _this.type = "ExperimentConfigurationNotFound";
        _this.message = message;
        return _this;
    }
    return ExperimentConfigurationNotFound;
}(Error));
exports.default = ExperimentConfigurationNotFound;

},{}],8:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var FeatureConfigurationNotFound = /** @class */ (function (_super) {
    __extends(FeatureConfigurationNotFound, _super);
    function FeatureConfigurationNotFound(message) {
        var _this = _super.call(this) || this;
        _this.type = "FeatureConfigurationNotFound";
        _this.message = message;
        return _this;
    }
    return FeatureConfigurationNotFound;
}(Error));
exports.default = FeatureConfigurationNotFound;

},{}],9:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var NotActivated = /** @class */ (function (_super) {
    __extends(NotActivated, _super);
    function NotActivated(message) {
        var _this = _super.call(this) || this;
        _this.type = "NotActivated";
        _this.message = message;
        return _this;
    }
    return NotActivated;
}(Error));
exports.default = NotActivated;

},{}],10:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var NotTargeted = /** @class */ (function (_super) {
    __extends(NotTargeted, _super);
    function NotTargeted(message) {
        var _this = _super.call(this) || this;
        _this.type = "NotTargeted";
        _this.message = message;
        return _this;
    }
    return NotTargeted;
}(Error));
exports.default = NotTargeted;

},{}],11:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteCodeDisabled = void 0;
var SiteCodeDisabled = /** @class */ (function (_super) {
    __extends(SiteCodeDisabled, _super);
    function SiteCodeDisabled(siteCode) {
        var _this = _super.call(this) || this;
        _this.type = "SiteCodeDisabled";
        _this.message = "SiteCode ".concat(siteCode, " disabled");
        return _this;
    }
    return SiteCodeDisabled;
}(Error));
exports.SiteCodeDisabled = SiteCodeDisabled;

},{}],12:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var VariationConfigurationNotFound = /** @class */ (function (_super) {
    __extends(VariationConfigurationNotFound, _super);
    function VariationConfigurationNotFound(message) {
        var _this = _super.call(this) || this;
        _this.type = "VariationConfigurationNotFound";
        _this.message = message;
        return _this;
    }
    return VariationConfigurationNotFound;
}(Error));
exports.default = VariationConfigurationNotFound;

},{}],13:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.VisitorCodeNotValid = void 0;
var VisitorCodeNotValid = /** @class */ (function (_super) {
    __extends(VisitorCodeNotValid, _super);
    function VisitorCodeNotValid(message) {
        var _this = _super.call(this) || this;
        _this.type = "VisitorCodeNotValid";
        _this.message = message;
        return _this;
    }
    return VisitorCodeNotValid;
}(Error));
exports.VisitorCodeNotValid = VisitorCodeNotValid;

},{}],14:[function(require,module,exports){
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KameleoonException = exports.KameleoonData = exports.KameleoonClient = void 0;
var configuration_1 = __importDefault(require("./configurations/configuration"));
var data_1 = __importDefault(require("./data"));
exports.KameleoonData = data_1.default;
var kameleoonUtils_1 = __importStar(require("./kameleoonUtils"));
var nonce_1 = __importDefault(require("./nonce"));
var targetingData_1 = __importDefault(require("./targeting/targetingData"));
var experimentConfigurationNotFound_1 = __importDefault(require("./exceptions/experimentConfigurationNotFound"));
var featureConfigurationNotFound_1 = __importDefault(require("./exceptions/featureConfigurationNotFound"));
var notActivated_1 = __importDefault(require("./exceptions/notActivated"));
var notTargeted_1 = __importDefault(require("./exceptions/notTargeted"));
var variationConfigurationNotFound_1 = __importDefault(require("./exceptions/variationConfigurationNotFound"));
var credentialsNotFound_1 = __importDefault(require("./exceptions/credentialsNotFound"));
var visitorCodeNotValid_1 = require("./exceptions/visitorCodeNotValid");
var siteCodeDisabled_1 = require("./exceptions/siteCodeDisabled");
var KameleoonClient = /** @class */ (function () {
    function KameleoonClient(siteCode, configuration) {
        var _this = this;
        this.ready = false;
        this.readyCallbacks = [];
        this.minutesBetweenConfigurationUpdate = 30;
        this.targetingData = {};
        this.unsentData = {};
        this.visitorDataMaximumSize = 1;
        this.environment = "production";
        this.updateConfiguration = function () {
            var data = localStorage.kameleoonJavaScriptClientData;
            if (data) {
                try {
                    data = JSON.parse(data);
                }
                catch (e) {
                    console.log(e);
                }
            }
            if (!data) {
                data = {
                    kameleoonTargetingData: {},
                    kameleoonConfiguration: {}
                };
            }
            var savedTargetingData = data.kameleoonTargetingData;
            if (savedTargetingData) {
                try {
                    _this.targetingData = savedTargetingData;
                    _this.emptyTargetingData();
                }
                catch (e) {
                    _this.targetingData = {};
                }
            }
            var savedConfiguration = data.kameleoonConfiguration;
            var needUpdate = false;
            if (!savedConfiguration) {
                needUpdate = true;
            }
            else {
                try {
                    var parsedConfiguration = new configuration_1.default(_this.siteCode, {
                        experiments: savedConfiguration.experiments,
                        featureFlags: savedConfiguration.featureFlags,
                        updateTime: savedConfiguration.updateTime
                    });
                    if (parsedConfiguration.updateTime < new Date().getTime() - (_this.minutesBetweenConfigurationUpdate * 1000 * 60)) {
                        needUpdate = true;
                    }
                    else {
                        _this.configurations = parsedConfiguration;
                    }
                }
                catch (e) {
                    needUpdate = true;
                }
            }
            if (needUpdate) {
                kameleoonUtils_1.default.doRequest("https://customers.kameleoon.com/mobile/configuration?siteCode=".concat(_this.siteCode, "&environment=").concat(_this.environment), kameleoonUtils_1.HttpMethod.GET, null, function (response) {
                    try {
                        _this.configurations = new configuration_1.default(_this.siteCode, JSON.parse(response));
                        _this.ready = true;
                        _this.clearCallbacks(true);
                        _this.save();
                    }
                    catch (e) {
                        console.log(e);
                    }
                });
            }
            else {
                _this.ready = true;
                _this.clearCallbacks(true);
            }
        };
        this.runWhenReady = function (successCallback, errorCallback, timeout) {
            if (_this.ready) {
                successCallback && successCallback();
            }
            else {
                _this.readyCallbacks.push({
                    error: errorCallback,
                    success: successCallback,
                    timeout: setTimeout(function () {
                        _this.clearCallbacks(false, errorCallback);
                    }, timeout)
                });
            }
        };
        this.clearCallbacks = function (success, errorCallback) {
            var callbacksToKeep = [];
            _this.readyCallbacks.forEach(function (c) {
                if (success) {
                    c.success && c.success();
                    clearTimeout(c.timeout);
                }
                else {
                    if (!success && errorCallback == c.error) {
                        c.error && c.error();
                    }
                    else {
                        callbacksToKeep.push(c);
                    }
                }
            });
            _this.readyCallbacks = callbacksToKeep;
        };
        this.trackConversion = function (visitorCode, goalId, revenue) {
            _this.validateVisitorCode(visitorCode);
            _this.addData(visitorCode, new data_1.default.Conversion(goalId, revenue, false));
            _this.flush(visitorCode);
        };
        this.flush = function (visitorCode) {
            if (visitorCode != null) {
                var body_1 = "";
                _this.getUnsentData(visitorCode).forEach(function (element) {
                    body_1 += element.obtainFullPostTextLine() + "\n";
                });
                kameleoonUtils_1.default.doRequest(KameleoonClient.API_SSX_URL + _this.getDataTrackingURL(visitorCode), kameleoonUtils_1.HttpMethod.POST, body_1, null);
                _this.emptyUnsentData(visitorCode);
            }
            else {
                _this.getUnsentUsers().forEach(function (vc) { return _this.flush(vc); });
            }
        };
        this.triggerExperiment = function (visitorCode, experimentId, timeout) {
            var _a;
            _this.validateVisitorCode(visitorCode);
            var xpConf = (_a = _this.configurations) === null || _a === void 0 ? void 0 : _a.experiments[experimentId];
            _this.checkSiteEnabled(xpConf);
            if (_this.checkTargeting(visitorCode, experimentId, false)) {
                var variationId = 0;
                var noneVariation = true;
                if (xpConf != null) {
                    var hashDouble = _this.obtainHashDouble(experimentId, visitorCode, xpConf);
                    var total = 0.0;
                    for (var key in xpConf.variationConfigurations) {
                        var variationConfiguration = xpConf.variationConfigurations[key];
                        total += variationConfiguration.deviation;
                        if (total >= hashDouble) {
                            noneVariation = false;
                            variationId = parseInt(key);
                            break;
                        }
                    }
                    var body_2 = "";
                    _this.getUnsentData(visitorCode).forEach(function (element) {
                        body_2 += element.obtainFullPostTextLine() + "\n";
                    });
                    kameleoonUtils_1.default.doRequest(KameleoonClient.API_SSX_URL + _this.getExperimentRegisterURL(visitorCode, experimentId, variationId, noneVariation), kameleoonUtils_1.HttpMethod.POST, body_2);
                }
                else {
                    throw new experimentConfigurationNotFound_1.default("KameleoonException.ExperimentConfigurationNotFound");
                }
                if (noneVariation) {
                    throw new notActivated_1.default("KameleoonException.NotActivated");
                }
                return variationId;
            }
            else {
                throw new notTargeted_1.default("KameleoonException.NotTargeted");
            }
        };
        this.activateFeature = function (visitorCode, featureIdOrName) {
            var _a, _b;
            _this.checkFeatureKeyOrId(featureIdOrName);
            _this.validateVisitorCode(visitorCode);
            var featureFlag = null;
            var featureId = -1;
            for (var key in (_a = _this.configurations) === null || _a === void 0 ? void 0 : _a.featureFlags) {
                var ff = (_b = _this.configurations) === null || _b === void 0 ? void 0 : _b.featureFlags[key];
                if (key == featureIdOrName || (ff === null || ff === void 0 ? void 0 : ff.identificationKey) == featureIdOrName) {
                    featureId = parseInt(key);
                    featureFlag = ff;
                }
            }
            _this.checkSiteEnabled(featureFlag);
            if (_this.checkTargeting(visitorCode, featureId, true)) {
                if (featureFlag && featureId) {
                    var result = false;
                    if (featureFlag.isScheduleActive()) {
                        var hashDouble = _this.obtainHashDouble(featureId, visitorCode, featureFlag);
                        var total = 0.0;
                        var variationId = 0;
                        var noneVariation = true;
                        for (var key in featureFlag.variationConfigurations) {
                            var variationConfiguration = featureFlag.variationConfigurations[key];
                            total += variationConfiguration.deviation;
                            if (total >= hashDouble) {
                                noneVariation = false;
                                variationId = parseInt(key);
                                break;
                            }
                        }
                        var body_3 = "";
                        _this.getUnsentData(visitorCode).forEach(function (element) {
                            body_3 += element.obtainFullPostTextLine() + "\n";
                        });
                        kameleoonUtils_1.default.doRequest(KameleoonClient.API_SSX_URL + _this.getExperimentRegisterURL(visitorCode, featureId, variationId, noneVariation), kameleoonUtils_1.HttpMethod.POST, body_3);
                        result = variationId != 0;
                    }
                    return result;
                }
                else {
                    throw new featureConfigurationNotFound_1.default("KameleoonException.FeatureConfigurationNotFound");
                }
            }
            else {
                throw new notTargeted_1.default("KameleoonException.NotTargeted");
            }
        };
        this.generateRandomString = function () {
            var alphabet = "abcdefghijklmnopqrstuvwxyz0123456789";
            var alphabetLength = alphabet.length;
            var randomVisitorCode = "";
            for (var i = 0; i < 16; ++i) {
                var randomNumber = Math.floor(Math.random() * alphabetLength);
                randomVisitorCode += alphabet[randomNumber];
            }
            return randomVisitorCode;
        };
        this.obtainVisitorCode = function (domain, defaultVisitorCode) {
            var value;
            var name = "kameleoonVisitorCode";
            var cookies = document.cookie.split(";");
            for (var i = 0, cookiesLength = cookies.length; i < cookiesLength; ++i) {
                var cookie = cookies[i];
                var valuePos = cookie.indexOf("=");
                if (cookie.substring(0, valuePos).trim() == name) {
                    value = cookie.substring(valuePos + 1);
                    break;
                }
            }
            if (value) {
                return value;
            }
            value = defaultVisitorCode || _this.generateRandomString();
            document.cookie = 'kameleoonVisitorCode=' + value + '; Max-Age=32832000; Path=/; Domain=' + domain;
            return value;
        };
        this.obtainHashDouble = function (containerId, visitorCode, xpConf) {
            var joinedRespoolTime = "";
            for (var variationId in xpConf.variationConfigurations) {
                var variation = xpConf.variationConfigurations[variationId];
                if (variation.respoolTime && variation.respoolTime != 0) {
                    joinedRespoolTime += variation.respoolTime;
                }
            }
            var identifier = visitorCode + containerId + joinedRespoolTime;
            var buff = kameleoonUtils_1.default.computeStringSha256(identifier);
            return parseInt(buff, 16) / Math.pow(2, 256);
        };
        this.getCommonSSXParameters = function (visitorCode) {
            return "&nonce=" + (0, nonce_1.default)() + "&siteCode=" + _this.siteCode + "&visitorCode=" + visitorCode;
        };
        this.getDataTrackingURL = function (visitorCode) {
            return "dataTracking?" + _this.getCommonSSXParameters(visitorCode);
        };
        this.getAPIDataRequestURL = function (key) {
            return KameleoonClient.API_DATA_URL + "data?siteCode=".concat(_this.siteCode, "&key=").concat(key);
        };
        this.getExperimentRegisterURL = function (visitorCode, experimentId, variationId, noneVariation) {
            var baseURL = "experimentTracking?" + _this.getCommonSSXParameters(visitorCode) + "&experimentId=" + experimentId;
            if (variationId == null) {
                return baseURL;
            }
            else {
                return baseURL + "&variationId=" + variationId + (noneVariation ? "&noneVariation=true" : "");
            }
        };
        this.getUnsentUsers = function () {
            return Object.getOwnPropertyNames(_this.unsentData);
        };
        this.getUnsentData = function (visitorCode) {
            if (!_this.unsentData[visitorCode]) {
                _this.unsentData[visitorCode] = [];
            }
            return _this.unsentData[visitorCode];
        };
        this.getTargetingData = function (visitorCode) {
            if (_this.targetingData[visitorCode] == null) {
                _this.targetingData[visitorCode] = [];
            }
            return _this.targetingData[visitorCode];
        };
        this.emptyUnsentData = function (visitorCode) {
            delete _this.unsentData[visitorCode];
        };
        this.emptyTargetingData = function () {
            var currentTime = new Date().getTime();
            for (var visitorCode in _this.targetingData) {
                _this.targetingData[visitorCode] = _this.targetingData[visitorCode].reduce(function (arr, data) {
                    if (data.lastActivityTime + KameleoonClient.MINUTES_SESSION_DURATION > currentTime) {
                        arr.push(data);
                    }
                    return arr;
                }, []);
            }
            _this.save();
        };
        this.addData = function (visitorCode) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            _this.validateVisitorCode(visitorCode);
            var listData = _this.getUnsentData(visitorCode);
            var targetingDataList = _this.getTargetingData(visitorCode);
            data.forEach(function (d) {
                listData.push(d);
                if (targetingDataList.length < _this.targetingDataNumberEntriesAuthorized) {
                    targetingDataList.push(new targetingData_1.default(new Date().getTime(), d));
                }
                else {
                    targetingDataList.splice(0, 1);
                    targetingDataList.push(new targetingData_1.default(new Date().getTime(), d));
                }
                _this.save();
            });
        };
        // Targeting Engine
        // check targeting
        this.checkTargeting = function (visitorCode, containerID, isFF) {
            var _a, _b;
            var targeting = true;
            var xpConf = null;
            // performing targeting
            if (isFF) {
                xpConf = (_a = _this.configurations) === null || _a === void 0 ? void 0 : _a.featureFlags[containerID];
            }
            else {
                xpConf = (_b = _this.configurations) === null || _b === void 0 ? void 0 : _b.experiments[containerID];
            }
            if (xpConf != null) {
                if (true == xpConf.forceTargeting) {
                    // assigning targeting to container
                    targeting = true;
                }
                else {
                    var targetingTree = void 0;
                    if (null != xpConf.targetingSegment) {
                        targetingTree = xpConf.targetingSegment.targetingTree;
                    }
                    // obtaining targeting checking result and assigning targeting to container
                    targeting = _this.checkTargetingTree(visitorCode, targetingTree);
                }
            }
            return targeting;
        };
        // check targeting tree
        this.checkTargetingTree = function (visitorCode, targetingTree) {
            var result = null;
            // checking if the tree has no targeting condition
            if (null == targetingTree) {
                result = true;
            }
            else {
                // checking if the tree is a leaf
                var targetingCondition = targetingTree.targetingCondition;
                if (null != targetingCondition) {
                    result = _this.checkTargetingCondition(visitorCode, targetingCondition);
                }
                else {
                    // computing left child result
                    var leftChildResult = _this.checkTargetingTree(visitorCode, targetingTree.leftChild);
                    var mustComputeRightChildResult = false;
                    if (true == leftChildResult) {
                        if (!targetingTree.orOperator) {
                            mustComputeRightChildResult = true; // true AND anything, needs to know the anything
                        }
                    }
                    else if (false == leftChildResult) {
                        if (targetingTree.orOperator) {
                            mustComputeRightChildResult = true; // false OR anything, needs to know the anything
                        }
                    }
                    else if (null == leftChildResult) {
                        mustComputeRightChildResult = true; // (undefined OR anything) or (undefined AND anything), needs to know the anything
                    }
                    // computing right child result if we must do it
                    var rightChildResult = null;
                    if (mustComputeRightChildResult) {
                        rightChildResult = _this.checkTargetingTree(visitorCode, targetingTree.rightChild);
                    }
                    // computing result
                    if (true == leftChildResult) {
                        if (targetingTree.orOperator) {
                            result = true; // true OR anything
                        }
                        else {
                            if (true == rightChildResult) {
                                result = true; // true AND true
                            }
                            else if (false == rightChildResult) {
                                result = false; // true AND false
                            }
                            else if (null == rightChildResult) {
                                result = null; // true AND undefined
                            }
                        }
                    }
                    else if (false == leftChildResult) {
                        if (targetingTree.orOperator) {
                            if (true == rightChildResult) {
                                result = true; // false OR true
                            }
                            else if (false == rightChildResult) {
                                result = false; // false OR false
                            }
                            else if (null == rightChildResult) {
                                result = null; // false OR undefined
                            }
                        }
                        else {
                            result = false; // false AND anything
                        }
                    }
                    else if (null == leftChildResult) {
                        if (targetingTree.orOperator) {
                            if (true == rightChildResult) {
                                result = true; // undefined OR true
                            }
                            else if (false == rightChildResult) {
                                result = null; // undefined OR false
                            }
                            else if (null == rightChildResult) {
                                result = null; // undefined OR undefined
                            }
                        }
                        else {
                            if (true == rightChildResult) {
                                result = null; // undefined AND true
                            }
                            else if (false == rightChildResult) {
                                result = false; // undefined AND false
                            }
                            else if (null == rightChildResult) {
                                result = null; // undefined AND undefined
                            }
                        }
                    }
                }
            }
            // returning result
            return result;
        };
        // check targeting condition
        this.checkTargetingCondition = function (visitorCode, targetingCondition) {
            var result = null;
            // obtaining targeting
            if (targetingCondition != null) {
                result = targetingCondition.check(_this.getTargetingData(visitorCode));
                // correcting targeting result in the case an exclusion rule is asked for
                if (true != targetingCondition.include) {
                    if (null == result) {
                        result = true;
                    }
                    else {
                        result = !result;
                    }
                }
            }
            else {
                result = true;
            }
            // returning result
            return result;
        };
        this.obtainVariationAssociatedData = function (variationId) {
            var _a, _b;
            for (var vid in (_a = _this.configurations) === null || _a === void 0 ? void 0 : _a.experiments) {
                var experiment = (_b = _this.configurations) === null || _b === void 0 ? void 0 : _b.experiments[vid];
                if (experiment === null || experiment === void 0 ? void 0 : experiment.variationConfigurations[variationId]) {
                    return experiment === null || experiment === void 0 ? void 0 : experiment.variationConfigurations[variationId].customJson;
                }
            }
            throw new variationConfigurationNotFound_1.default("KameleoonException.VariationConfigurationNotFound");
        };
        this.obtainFeatureVariable = function (featureIdOrName, variable) {
            var _a, _b, _c;
            _this.checkFeatureKeyOrId(featureIdOrName);
            for (var ffid in (_a = _this.configurations) === null || _a === void 0 ? void 0 : _a.featureFlags) {
                var ff = (_b = _this.configurations) === null || _b === void 0 ? void 0 : _b.featureFlags[ffid];
                if (ffid == featureIdOrName || (ff === null || ff === void 0 ? void 0 : ff.identificationKey) == featureIdOrName) {
                    for (var vid in ff === null || ff === void 0 ? void 0 : ff.variationConfigurations) {
                        if (vid != "0") {
                            return _this._parseJsonValue((_c = ff === null || ff === void 0 ? void 0 : ff.variationConfigurations[vid]) === null || _c === void 0 ? void 0 : _c.customJson[variable]);
                        }
                    }
                }
            }
            throw new featureConfigurationNotFound_1.default("KameleoonException.FeatureConfigurationNotFound");
        };
        this.retrieveDataFromRemoteSource = function (key) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        kameleoonUtils_1.default.doRequest(_this.getAPIDataRequestURL(key), kameleoonUtils_1.HttpMethod.GET, null, function (response) {
                            resolve(JSON.parse(response));
                        });
                    })];
            });
        }); };
        this._parseJsonValue = function (obj) {
            if (obj == null) {
                throw new featureConfigurationNotFound_1.default("KameleoonException.FeatureConfigurationNotFound");
            }
            else {
                switch (obj.type) {
                    case 'Boolean':
                        return obj.value == 'True';
                    case 'Number':
                        return parseInt(obj.value);
                    case 'JSON':
                        return JSON.stringify(obj.value);
                    default:
                        return obj.value;
                }
            }
        };
        this.save = function () {
            var _a, _b;
            if (_this.configurations) {
                var data = {
                    kameleoonTargetingData: _this.targetingData,
                    kameleoonConfiguration: {
                        updateTime: _this.configurations.updateTime,
                        experiments: (_a = _this.configurations.configuration) === null || _a === void 0 ? void 0 : _a.experiments,
                        featureFlags: (_b = _this.configurations.configuration) === null || _b === void 0 ? void 0 : _b.featureFlags,
                    }
                };
                try {
                    localStorage.setItem("kameleoonJavaScriptClientData", JSON.stringify(data));
                }
                catch (e) {
                    console.log(e);
                }
            }
        };
        this.validateVisitorCode = function (visitorCode) {
            if (visitorCode == null || visitorCode.length == 0) {
                throw new visitorCodeNotValid_1.VisitorCodeNotValid("Visitor code is empty");
            }
            else if (visitorCode.length > KameleoonClient.VISITOR_CODE_MAX_LENGTH) {
                throw new visitorCodeNotValid_1.VisitorCodeNotValid("Visitor code max length is " + KameleoonClient.VISITOR_CODE_MAX_LENGTH + " characters");
            }
        };
        this.siteCode = siteCode;
        if (configuration) {
            if (configuration.visitor_data_maximum_size) {
                this.visitorDataMaximumSize = configuration.visitor_data_maximum_size;
            }
            if (configuration.actions_configuration_refresh_interval) {
                this.minutesBetweenConfigurationUpdate = configuration.actions_configuration_refresh_interval;
            }
            if (configuration.environment) {
                this.environment = configuration.environment;
            }
        }
        this.targetingDataNumberEntriesAuthorized = this.visitorDataMaximumSize * 1000000 / KameleoonClient.TARGETING_DATA_MAXIMUM_SIZE_BYTES;
        this.updateConfiguration();
        setInterval(this.emptyTargetingData, KameleoonClient.DEFAULT_MILLISECONDS_BETWEEN_TARGETING_DATA_UPDATE);
    }
    KameleoonClient.prototype.checkSiteEnabled = function (experimentOrFeatureFlag) {
        if (experimentOrFeatureFlag != null && !experimentOrFeatureFlag.siteEnabled) {
            throw new siteCodeDisabled_1.SiteCodeDisabled(this.siteCode);
        }
    };
    KameleoonClient.prototype.checkFeatureKeyOrId = function (featureIdOrName) {
        if (typeof featureIdOrName === "string") {
            console.log("Please use `featureIdOrName` with type of `string`. This is necessary to support multi-environment feature. Supporting of `number` type will be removed in next releases");
        }
    };
    KameleoonClient.DEFAULT_MILLISECONDS_BETWEEN_TARGETING_DATA_UPDATE = 1800000;
    KameleoonClient.MINUTES_SESSION_DURATION = 30 * 60 * 1000;
    KameleoonClient.TARGETING_DATA_MAXIMUM_SIZE_BYTES = 500;
    KameleoonClient.API_SSX_URL = "https://api-ssx.kameleoon.com/";
    KameleoonClient.API_DATA_URL = "https://api-data.kameleoon.com/";
    KameleoonClient.VISITOR_CODE_MAX_LENGTH = 255;
    if (typeof window !== 'undefined') { window.KameleoonClient = KameleoonClient; } else if (typeof global !== 'undefined') { global.KameleoonClient = KameleoonClient; } 
    return KameleoonClient;
}());
exports.KameleoonClient = KameleoonClient;
var KameleoonException = {
    ExperimentConfigurationNotFound: experimentConfigurationNotFound_1.default,
    FeatureConfigurationNotFound: featureConfigurationNotFound_1.default,
    VariationConfigurationNotFound: variationConfigurationNotFound_1.default,
    NotTargeted: notTargeted_1.default,
    NotActivated: notActivated_1.default,
    CredentialsNotFound: credentialsNotFound_1.default
};
exports.KameleoonException = KameleoonException;

},{"./configurations/configuration":1,"./data":5,"./exceptions/credentialsNotFound":6,"./exceptions/experimentConfigurationNotFound":7,"./exceptions/featureConfigurationNotFound":8,"./exceptions/notActivated":9,"./exceptions/notTargeted":10,"./exceptions/siteCodeDisabled":11,"./exceptions/variationConfigurationNotFound":12,"./exceptions/visitorCodeNotValid":13,"./kameleoonUtils":15,"./nonce":16,"./targeting/targetingData":20}],15:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpMethod = void 0;
var VERSION = "1.0.7";
var KameleoonUtils = /** @class */ (function () {
    function KameleoonUtils() {
        var _this = this;
        this.doRequest = function (url, method, data, callback) {
            var xhr = new XMLHttpRequest();
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    callback && callback(xhr.response);
                }
            };
            xhr.open(method, url, true);
            xhr.setRequestHeader("Kameleoon-Client", "sdk/js/" + VERSION);
            xhr.send(data ? data : null);
        };
        this.computeStringSha256 = function (string) {
            var i = 1, j;
            var K = [], H = [];
            while (++i < 18) {
                for (j = i * i; j < 312; j += i) {
                    K[j] = 1;
                }
            }
            function x(num, root) {
                return ((Math.pow(num, 1 / root) % 1) * 4294967296) | 0;
            }
            for (i = 1, j = 0; i < 313;) {
                if (!K[++i]) {
                    H[j] = x(i, 2);
                    K[j++] = x(i, 3);
                }
            }
            function S(X, n) {
                return (X >>> n) | (X << (32 - n));
            }
            var HASH = H.slice((i = 0)), W = [], m = [];
            var s = _this.encodeUTF8(string), l = s.length, a, y, z;
            for (; i < l;)
                m[i >> 2] |= (s.charCodeAt(i) & 0xff) << (8 * (3 - (i++ % 4)));
            l *= 8;
            m[l >> 5] |= 0x80 << (24 - (l % 32));
            m[(z = ((l + 64) >> 5) | 15)] = l;
            for (i = 0; i < z; i += 16) {
                a = HASH.slice((j = 0), 8);
                for (; j < 64; a[4] += y) {
                    if (j < 16) {
                        W[j] = m[j + i];
                    }
                    else {
                        W[j] =
                            (S((y = W[j - 2]), 17) ^ S(y, 19) ^ (y >>> 10)) +
                                (W[j - 7] | 0) +
                                (S((y = W[j - 15]), 7) ^ S(y, 18) ^ (y >>> 3)) +
                                (W[j - 16] | 0);
                    }
                    var b = void 0;
                    a.unshift((y =
                        ((a.pop() + (S((b = a[4]), 6) ^ S(b, 11) ^ S(b, 25)) + (((b & a[5]) ^ (~b & a[6])) + K[j])) | 0) +
                            (W[j++] | 0)) +
                        (S((l = a[0]), 2) ^ S(l, 13) ^ S(l, 22)) +
                        ((l & a[1]) ^ (a[1] & a[2]) ^ (a[2] & l)));
                }
                for (j = 8; j--;)
                    HASH[j] = a[j] + HASH[j];
            }
            for (s = ""; j < 63;)
                s += ((HASH[++j >> 3] >> (4 * (7 - (j % 8)))) & 15).toString(16);
            return s;
        };
        this.encodeUTF8 = function (string) {
            string = string.replace(/\r\n/g, "\n");
            var utftext = "";
            for (var n = 0; n < string.length; n++) {
                var c = string.charCodeAt(n);
                if (c < 128) {
                    utftext += String.fromCharCode(c);
                }
                else if (c > 127 && c < 2048) {
                    utftext += String.fromCharCode((c >> 6) | 192);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
                else {
                    utftext += String.fromCharCode((c >> 12) | 224);
                    utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                    utftext += String.fromCharCode((c & 63) | 128);
                }
            }
            return utftext;
        };
    }
    return KameleoonUtils;
}());
var HttpMethod;
(function (HttpMethod) {
    HttpMethod["GET"] = "GET";
    HttpMethod["POST"] = "POST";
})(HttpMethod = exports.HttpMethod || (exports.HttpMethod = {}));
exports.default = new KameleoonUtils;

},{}],16:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var HEXADECIMAL_ALPHABET = "0123456789ABCDEF";
var NONCE_BYTE_LENGTH = 8;
var obtainNonce = function () {
    var alphabetLength = HEXADECIMAL_ALPHABET.length;
    var result = "";
    for (var i = 0; i < NONCE_BYTE_LENGTH * 2; ++i) {
        var randomNumber = Math.floor(Math.random() * alphabetLength);
        result += HEXADECIMAL_ALPHABET.substring(randomNumber, randomNumber + 1);
    }
    return result;
};
exports.default = obtainNonce;

},{}],17:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var targetingCondition_1 = __importDefault(require("../targetingCondition"));
var CustomDatum = /** @class */ (function (_super) {
    __extends(CustomDatum, _super);
    function CustomDatum(index, value, isInclude, matchType) {
        var _this = _super.call(this) || this;
        _this.check = function (data) {
            var targeting = true;
            var customData = data.filter(function (d) {
                var data = d.data;
                return data.type == "CustomData" && data.id == _this.index;
            }).map(function (d) {
                return d.data;
            });
            if (customData.length == 0) {
                targeting = _this.operator == "UNDEFINED";
            }
            else {
                targeting = false;
                var customDatum = customData.slice(-1)[0];
                switch (_this.operator) {
                    case "CONTAINS":
                        if (customDatum.value.indexOf(_this.value) >= 0) {
                            targeting = true;
                        }
                        break;
                    case "EXACT":
                        if (customDatum.value == _this.value) {
                            targeting = true;
                        }
                        break;
                    case "REGULAR_EXPRESSION":
                        if (customDatum.value.match(_this.value)) {
                            targeting = true;
                        }
                        break;
                    case "LOWER":
                    case "EQUAL":
                    case "GREATER": {
                        var number = parseFloat(_this.value);
                        if (!isNaN(number)) {
                            var valueNumber = parseFloat(customDatum.value);
                            if (!isNaN(valueNumber)) {
                                switch (_this.operator) {
                                    case "LOWER":
                                        if (valueNumber < number) {
                                            targeting = true;
                                        }
                                        break;
                                    case "EQUAL":
                                        if (valueNumber == number) {
                                            targeting = true;
                                        }
                                        break;
                                    case "GREATER":
                                        if (valueNumber > number) {
                                            targeting = true;
                                        }
                                        break;
                                }
                            }
                        }
                        break;
                    }
                    case "TRUE":
                        if (customDatum.value == "true") {
                            targeting = true;
                        }
                        break;
                    case "FALSE":
                        if (customDatum.value == "false") {
                            targeting = true;
                        }
                        break;
                }
            }
            return targeting;
        };
        _this.include = isInclude;
        _this.type = "customDatum";
        _this.index = index;
        _this.value = value;
        _this.operator = matchType;
        return _this;
    }
    return CustomDatum;
}(targetingCondition_1.default));
exports.default = CustomDatum;

},{"../targetingCondition":18}],18:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TargetingCondition = /** @class */ (function () {
    function TargetingCondition() {
    }
    return TargetingCondition;
}());
exports.default = TargetingCondition;

},{}],19:[function(require,module,exports){
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var customDatum_1 = __importDefault(require("./conditions/customDatum"));
var TargetingConditionsFactory = /** @class */ (function () {
    function TargetingConditionsFactory() {
    }
    TargetingConditionsFactory.prototype.getCondition = function (targetingConditionType, conditionData) {
        if (targetingConditionType == "CUSTOM_DATUM") {
            return new customDatum_1.default(parseInt(conditionData.customDataIndex), conditionData.value, conditionData.isInclude, conditionData.valueMatchType);
        }
        return null;
    };
    return TargetingConditionsFactory;
}());
exports.default = TargetingConditionsFactory;

},{"./conditions/customDatum":17}],20:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TargetingData = /** @class */ (function () {
    function TargetingData(lastActivityTime, data) {
        this.lastActivityTime = lastActivityTime;
        this.data = data;
    }
    return TargetingData;
}());
exports.default = TargetingData;

},{}],21:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TargetingSegment = /** @class */ (function () {
    function TargetingSegment() {
    }
    return TargetingSegment;
}());
exports.default = TargetingSegment;

},{}],22:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var TargetingTree = /** @class */ (function () {
    function TargetingTree(orOperator, leftChild, rightChild, targetingCondition) {
        this.orOperator = orOperator;
        this.leftChild = leftChild;
        this.rightChild = rightChild;
        this.targetingCondition = targetingCondition;
    }
    return TargetingTree;
}());
exports.default = TargetingTree;

},{}],23:[function(require,module,exports){
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var targetingConditionsFactory_1 = __importDefault(require("./targetingConditionsFactory"));
var targetingTree_1 = __importDefault(require("./targetingTree"));
var TargetingTreeBuilder = /** @class */ (function () {
    function TargetingTreeBuilder() {
    }
    TargetingTreeBuilder.createIterator = function (array) {
        var nextIndex = 0;
        return {
            hasNext: function () {
                return nextIndex < array.length;
            },
            next: function () {
                return array[nextIndex++];
            }
        };
    };
    TargetingTreeBuilder.createTargetingTree = function (conditions) {
        if (conditions == null) {
            return null;
        }
        var conditionsFirstLevel = [];
        var jArrayConditionsFirstLevel = conditions.firstLevel;
        if (jArrayConditionsFirstLevel != null) {
            for (var i = 0; i < jArrayConditionsFirstLevel.length; i++) {
                conditionsFirstLevel.push(jArrayConditionsFirstLevel[i]);
            }
        }
        var firstLevelIterator = TargetingTreeBuilder.createIterator(conditionsFirstLevel);
        var firstLevelOrOperatorsIterator;
        var firstLevelOrOperators = [];
        var jArrayFirstLevelOrOperators = conditions.firstLevelOrOperators;
        if (jArrayFirstLevelOrOperators != null) {
            for (var j = 0; j < jArrayFirstLevelOrOperators.length; j++) {
                firstLevelOrOperators.push(jArrayFirstLevelOrOperators[j]);
            }
        }
        if (firstLevelIterator.hasNext()) {
            firstLevelOrOperatorsIterator = TargetingTreeBuilder.createIterator(firstLevelOrOperators);
        }
        return TargetingTreeBuilder.createTargetingTreeFirstLevel(firstLevelOrOperatorsIterator, firstLevelIterator);
    };
    TargetingTreeBuilder.createTargetingTreeFirstLevel = function (firstLevelOrOperatorsIterator, firstLevelIterator) {
        if (firstLevelIterator && firstLevelIterator.hasNext()) {
            var leftFirstLevelMap = firstLevelIterator.next();
            var conditions = [];
            var jArrayConditions = leftFirstLevelMap.conditions;
            if (jArrayConditions != null) {
                for (var i = 0; i < jArrayConditions.length; i++) {
                    conditions.push(jArrayConditions[i]);
                }
            }
            var orOperators = [];
            var jArrayOrOperators = leftFirstLevelMap.orOperators;
            if (jArrayOrOperators != null) {
                for (var j = 0; j < jArrayOrOperators.length; j++) {
                    orOperators.push(jArrayOrOperators[j]);
                }
            }
            var leftChild = TargetingTreeBuilder.createTargetingTreeSecondLevel(TargetingTreeBuilder.createIterator(orOperators), TargetingTreeBuilder.createIterator(conditions));
            if (firstLevelOrOperatorsIterator && firstLevelIterator.hasNext()) {
                var orOperator = firstLevelOrOperatorsIterator.next();
                if (orOperator) {
                    return new targetingTree_1.default(orOperator, leftChild, TargetingTreeBuilder.createTargetingTreeFirstLevel(firstLevelOrOperatorsIterator, firstLevelIterator));
                }
                var rightFirstLevelMap = firstLevelIterator.next();
                var rightConditions = [];
                var jArrayRightConditions = rightFirstLevelMap.conditions;
                if (jArrayRightConditions != null) {
                    for (var k = 0; k < jArrayRightConditions.length; k++) {
                        rightConditions.push(jArrayRightConditions[k]);
                    }
                }
                var rightOrOperators = [];
                var jArrayRightOrOperators = rightFirstLevelMap.orOperators;
                if (jArrayRightOrOperators != null) {
                    for (var p = 0; p < jArrayRightOrOperators.length; p++) {
                        rightOrOperators.push(jArrayRightOrOperators[p]);
                    }
                }
                var rightChild = TargetingTreeBuilder.createTargetingTreeSecondLevel(TargetingTreeBuilder.createIterator(rightOrOperators), TargetingTreeBuilder.createIterator(rightConditions));
                var leftAndRightChildren = new targetingTree_1.default(orOperator, leftChild, rightChild);
                if (firstLevelIterator.hasNext()) {
                    return new targetingTree_1.default(firstLevelOrOperatorsIterator.next(), leftAndRightChildren, TargetingTreeBuilder.createTargetingTreeFirstLevel(firstLevelOrOperatorsIterator, firstLevelIterator));
                }
                return leftAndRightChildren;
            }
            return leftChild;
        }
        return null;
    };
    TargetingTreeBuilder.createTargetingTreeSecondLevel = function (secondLevelOrOperatorsIterator, secondLevelConditionsIterator) {
        if (secondLevelConditionsIterator && secondLevelConditionsIterator.hasNext()) {
            var condition = secondLevelConditionsIterator.next();
            var targetingConditionsFactory = new targetingConditionsFactory_1.default();
            var targetingCondition = targetingConditionsFactory.getCondition(condition.targetingType, condition);
            var leftChild = new targetingTree_1.default();
            leftChild.targetingCondition = targetingCondition;
            if (secondLevelOrOperatorsIterator && secondLevelOrOperatorsIterator.hasNext()) {
                var orOperator = secondLevelOrOperatorsIterator.next();
                if (orOperator) {
                    return new targetingTree_1.default(orOperator, leftChild, TargetingTreeBuilder.createTargetingTreeSecondLevel(secondLevelOrOperatorsIterator, secondLevelConditionsIterator));
                }
                var rightCondition = secondLevelConditionsIterator.next();
                var rightTargetingCondition = targetingConditionsFactory.getCondition(rightCondition.targetingType, rightCondition);
                var rightChild = new targetingTree_1.default();
                rightChild.targetingCondition = rightTargetingCondition;
                var leftAndRightChildren = new targetingTree_1.default(orOperator, leftChild, rightChild);
                if (secondLevelConditionsIterator.hasNext()) {
                    return new targetingTree_1.default(secondLevelOrOperatorsIterator.next(), leftAndRightChildren, TargetingTreeBuilder.createTargetingTreeSecondLevel(secondLevelOrOperatorsIterator, secondLevelConditionsIterator));
                }
                return leftAndRightChildren;
            }
            return leftChild;
        }
        return null;
    };
    return TargetingTreeBuilder;
}());
exports.default = TargetingTreeBuilder;

},{"./targetingConditionsFactory":19,"./targetingTree":22}]},{},[14]);
