import 'kameleoon_client.dart';
import 'internal/kameleoon_client_impl.dart'
    if (dart.library.js) 'internal/kameleoon_client_impl_web.dart';

/// [KameleoonClientFactory] to create [KameleoonClient] instance depending of siteCode
abstract class KameleoonClientFactory {
  static final Map<String, KameleoonClient> _clients = {};

  /// Create or return the instance of [KameleoonClient] depending of the siteCode
  static KameleoonClient? create(String siteCode, [String environment = "production"]) {
    if (!_clients.containsKey(siteCode)) {
      final instance = KameleoonClientImpl(siteCode, environment);
      _clients[siteCode] = instance;
    }
    return _clients[siteCode];
  }

  static void forget(String siteCode) {
    _clients.remove(siteCode);
  }
}
