/// Abstract class Datafor all tracking data
abstract class Data {
  String? dataType;
}
/// Uses for tracking any type of data
class CustomData implements Data {
  int? id;
  String? value;
  String? dataType = "CustomData";

  CustomData(int id, String value) {
    this.id = id;
    this.value = value;
  }
}
/// Uses for tracking page (url, title , referrer)
class PageView implements Data {
  String? url;
  String? title;
  int? referrer;
  String? dataType = "PageView";

  PageView(String url, String title, int referrer) {
    this.url = url;
    this.title = title;
    this.referrer = referrer;
  }
}
/// Uses for tracking interest(index)
class Interest implements Data {
  int? index;
  String? dataType = "Interest";

  Interest(int index) {
    this.index = index;
  }
}
/// Uses for tracking conversion(goalId, revenue, negative)
class Conversion implements Data {
  int? goalId;
  double? revenue;
  bool? negative;
  String? dataType = "Conversion";

  Conversion(int goalId, {double? revenue, bool? negative}) {
    this.goalId = goalId;
    this.revenue = revenue == null ? 0 : revenue;
    this.negative = negative == null ? false : negative;
  }
}

enum Browsers { CHROME, INTERNET_EXPLORER, FIREFOX, SAFARI, OPERA, OTHER }

/// Uses for tracking browser client
class Browser implements Data {
  int? browser;
  String? dataType = "Browser";

  Browser(Browsers browser) {
    this.browser = browser.index;
  }
}
